;-----------------------------------
; autohotkey script for silently adding to Xmplay playlist through DDE
;  takes file(s)/folder(s)/playlist(s) as input parameter
; - drop input on AHK_xmplay_input_to_playlist_DDEML.exe or
; - pass input as quote enclosed, space separated command line parameters 
;  (use no end slash for folders!)
;   example: C:\AHK_xmplay_input_to_playlist_DDEML.exe "C:\musicfolder" "C:\music2\song.mp3"
;
; made by nod5 , version 080821
; using DDEML by sean, http://www.autohotkey.com/forum/topic19169.html
;-----------------------------------

if 0 = 0		;-- if no parameters
 exitapp

IfWinNotExist, ahk_class XMPLAY-MAIN
 {
 IfExist, %A_ScriptDir%\xmplay\xmplay.exe
   Run, %A_ProgramFiles%\xmplay\xmplay.exe
 Else IfExist, %A_ProgramFiles%\xmplay\xmplay.exe
  Run, %A_ProgramFiles%\xmplay\xmplay.exe
 Else 
  exitapp 
sleep 500
  }

 /*			;-- adding files one by one works but is slow
 Loop, %0%  {		;-- loop over input parameters
xx := %A_Index%
gosub xsend
}	
*/

xtemp = 
Loop, %0%  {		;-- loop over input parameters
xparam := %A_Index%
FileGetAttrib, xattr, %xparam%
IfInString, xattr, D	;-- .pls playlist can't contain directories so add them separately
 { 
 xx = %xparam%
 gosub xsend
 }
else 
 xtemp = %xtemp%%xparam%`n		;-- add files to linebreak separated variable
}
xtemplist = %A_Temp%\%A_now%.pls	;-- make playlist, add to xmplay, then delete
FileAppend, %xtemp%, %xtemplist%
xx = %xtemplist%
gosub xsend
FileDelete, %xtemplist%
exitapp

;-----------------------------------
xsend:
sServer := "xmplay"
sTopic  := "system" 
sData   := "[list(" . xx . ")]"

idInst  := DdeInitialize() 
hServer := DdeCreateStringHandle(idInst, sServer) 
hTopic  := DdeCreateStringHandle(idInst, sTopic ) 
hConv   := DdeConnect(idInst, hServer, hTopic) 
hData   := DdeClientTransaction(0x4050, hConv, 0, sData) 

DdeFreeStringHandle(idInst, hServer) 
DdeFreeStringHandle(idInst, hTopic ) 
DdeDisconnect(hConv) 
DdeUninitialize(idInst) 

return

;-----------------------------------
DdeInitialize(pCallback = 0, nFlags = 0)
{
   DllCall("DdeInitialize", "UintP", idInst, "Uint", pCallback, "Uint", nFlags, "Uint", 0)
   Return idInst
}

DdeUninitialize(idInst)
{
   Return DllCall("DdeUninitialize", "Uint", idInst)
}

DdeConnect(idInst, hServer, hTopic, pCC = 0)
{
   Return DllCall("DdeConnect", "Uint", idInst, "Uint", hServer, "Uint", hTopic, "Uint", pCC)
}

DdeDisconnect(hConv)
{
   Return DllCall("DdeDisconnect", "Uint", hConv)
}

DdeAccessData(hData)
{
   Return DllCall("DdeAccessData", "Uint", hData, "Uint", 0, "str")
}

DdeUnaccessData(hData)
{
   Return DllCall("DdeUnaccessData", "Uint", hData)
}

DdeFreeDataHandle(hData)
{
   Return DllCall("DdeFreeDataHandle", "Uint", hData)
}

DdeCreateStringHandle(idInst, sString, nCodePage = 1004)         ; CP_WINANSI = 1004
{
   Return DllCall("DdeCreateStringHandle", "Uint", idInst, "Uint", &sString, "int", nCodePage)
}

DdeFreeStringHandle(idInst, hString)
{
   Return DllCall("DdeFreeStringHandle", "Uint", idInst, "Uint", hString)
}

DdeClientTransaction(nType, hConv, hItem, sData = "", nFormat = 1, nTimeOut = 10000)   ; CF_TEXT = 1
{
   Return DllCall("DdeClientTransaction", "Uint", sData = "" ? 0 : &sData, "Uint", sData = "" ? 0 : StrLen(sData)+1, "Uint", hConv, "Uint", hItem, "Uint", nFormat, "Uint", nType, "Uint", nTimeOut, "UintP", nResult)
}
